<?
/*
//
// Script cre par : Bisous Partout des GrosBilloux [BG]
// Le : 11/03/06.
//
// Librairies utilises : cURL, GD.
// 
*/

$db=new MySQL_Class(DATABASE,DOMAINE,IDENTIFIANT,MDP); //Crer une connexion  la base

/*
//
// Fonction : GetHTMLSource()
//
// Ecrit par : Bisous Partout.
// Le : 11/03/06.
//
// Constantes utilises :
	URL_LADDER
	NOM_GUILD
//
// Paramtres :
	Aucun.
//
// Description :
	Renvoie la source de la page du ladder de GuildWars
*/
function GetHTMLSource(){
	$ch = curl_init(); //Initialisation de cURL
	do{
		$URL=URL_LADDER."?name=".NOM_GUILD; //Construction de l'URL
		curl_setopt($ch,CURLOPT_URL,$URL); //Paramtre l'URL
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,1); //Option pour rcuprer le code source de la page dans une variable
		$html_source=curl_exec($ch); //Enregistrement du code source de la page dans une variable
	}while(curl_error($ch)); //Tant qu'on arrive pas  rcuprer le code source de la page, on recommence
	curl_close($ch); //Fermeture de cURL
	return($html_source); //Retourne le code source de la page
}

/*
//
// Fonction : GetGuildInfo($html_source)
//
// Ecrit par : Bisous Partout.
// Le : 11/03/06.
//
// Constantes utilises
	DEBUT
	FIN
	SEP
//
// Paramtres :
	Aucun.
//
// Description :
	Extrait les informations de la guilde, les stock dans un tableau et renvoie le tableau.
*/
function GetGuildInfo(){
	$html_source=GetHTMLSource();
	//Extrait les informations de la guilde (Format HTML)
	$pos_ranking_tag=strpos($html_source,DEBUT); //Calcul la position de dpart pour l'extraction
	$pos_table_end=strpos($html_source,FIN); //Calcul la position de fin pour l'extraction
	$extract_length=$pos_table_end-$pos_ranking_tag; //Calcul le nombre de caractres  extraire (position de fin - position de dpart)
	$html_source=substr($html_source,$pos_ranking_tag,$extract_length); //Extrait les informations dans la variable html_source
	////
	
	$guild_info=explode(SEP,$html_source); //Crer un tableau contenant les informations
	$nb_indice=count($guild_info); //Rcupre le nombre d'indices du tableau
	for($i=0;$i<$nb_indice;$i++){
		$guild_info[$i]=strip_tags($guild_info[$i]); //Retire tous les tags HTML dans le tableau
	}
	return($guild_info); //Retourne le tableau
}

/*
//
// Fonction : CreateImage($Nom,$img)
//
// Ecrit par : Bisous Partout.
// Le : 11/03/06.
//
// Constantes utilises
	H_MATIN
	H_SOIR
	NOM_GUILD
	QUALITE_JPEG
//
// Paramtres :
	Nom du personnage qui sera affich
	Nom de l'image utilise pour la signature
//
// Description :
	Crer l'image en y ajoutant les informations de la guilde (rank, rating, wins, looses, etc.).
*/
function CreateImage($nom,$img){
	if((date("H")>=H_SOIR) or (date("H")<=H_MATIN)){
		$bg_path="Images/".$img."_nuit.jpg"; //Version nuit
	}else{
		$bg_path="Images/".$img."_jour.jpg"; //Version jour
	}
	
	$image=imagecreatefromjpeg($bg_path); //Crer l'image  partir d'un JPEG
	
	//Couleurs utilises (on peut en rajouter en suivant la mme syntaxe (Image,R,V,B)).
	$noir=imagecolorallocate($image,0,0,0); //Noir
	$blanc=imagecolorallocate($image,255,255,255); //Blanc
	$rouge=imagecolorallocate($image,255,60,60); //Rouge
	$vert=imagecolorallocate($image,60,255,60); //Vert
	////
	
	/*Polices utilises (on peut en rajouter en suivant la mme syntaxe et en copiant les polices 
	dsires dans le rpertoire Fonts toutefois seul les polices TrueType peuvent tre utilises).*/
	$sylf=realpath('./Fonts/sylfaen.ttf'); //Sylfaen Normal
	$verda=realpath('./Fonts/verdana.ttf'); //Verdana Normal
	$verdab=realpath('./Fonts/verdanab.ttf'); //Verdana Bold
	////
	
	//Extrait les donnes de la base
	$guild_info=GetGuildInfoFromDB();
	//Range les donnes dans les variables
	$rank=$guild_info[0]; //Rang
	$rating=$guild_info[1]; //Classement
	$wins=$guild_info[2]; //Victoires
	$looses=$guild_info[3]; //Dfaites
	////
	
	//Extrait les donnes de la base
	$db_guild_info=GetGuildStatsFromDB();
	//Range les donnes dans des variables
	$stat_rank=$rank-$db_guild_info[0]; //Rang
	$stat_rating=$rating-$db_guild_info[1]; //Classement
	$stat_wins=$wins-$db_guild_info[2]; //Victoires
	$stat_looses=$looses-$db_guild_info[3]; //Dfaites
	////
	
	//Formatage des stats
	if(preg_match("!^-!",$stat_rank)){ //Si le nombre est ngatif
		//$stat_rank="+".$stat_rank; //On remplace le "-" par un "+"
		$stat_rank=str_replace("-","+",$stat_rank);
	}else{ //Sinon si le nombre est positif
		$stat_rank="-".$stat_rank; //On met un "-" devant
	}
	if(!preg_match("!^-!",$stat_rating)){ //Si le nombre n'est pas ngatif
		$stat_rating="+".$stat_rating; //On ajoute un "+" devant
	}
	$stat_wins="+".$stat_wins; //On met un "+" devant
	$stat_looses="+".$stat_looses; //On met un "+" devant
	////
	
	$nom_guild=preg_replace('!\+!',' ',NOM_GUILD); //Remplace les + par un espace dans le nom de la guilde
	
	//Texte
	imagettftext($image,16,0,10,25,$blanc,$sylf,$nom); //Nom du joueur
	imagettftext($image,16,0,10,48,$blanc,$sylf,$nom_guild); //Nom de la guilde
	imagettftext($image,12,0,155,48,$blanc,$sylf,"$rank ($stat_rank)"); //Rang de la guilde
	imagettftext($image,10,0,10,66,$blanc,$sylf,"Classement : $rating ($stat_rating)"); //Classement de la guilde
	imagettftext($image,10,0,10,81,$blanc,$sylf,"Victoires : $wins ($stat_wins)"); //Victoires de la guilde
	imagettftext($image,10,0,120,81,$blanc,$sylf,"Dfaites : $looses ($stat_looses)"); //Dfaites de la guilde
	////
	
	$nom=preg_replace('! !','_',$nom); //Remplace les espaces par des underscore ( _ )
	imagejpeg($image,"Images/Signatures/$nom.jpg",QUALITE_JPEG); //Enregistre l'image
}

/*
//
// Fonction : AddToDB($nom)
//
// Ecrit par : Bisous Partout.
// Le : 11/03/06.
//
// Constantes utilises
	Aucune.
//
// Paramtres :
	Nom du personnage qui sera enregistr dans la base
	Nom de l'image utilise pour la signature
//
// Description :
	Enregistre le nom du personnage dans la base de donnes pour pouvoir raffraichir la signature.
*/
function AddToDB($nom,$img){
	$maintenant=date("d/m/Y H:i:s"); //Date d'aujourd'hui
	$ip=$_SERVER['REMOTE_ADDR']; //Adresse IP de l'utilisateur
	global $db; //Dclare que la variable $bdd est une variable globale
	if($db->Query("SELECT nom FROM utilisateurs WHERE nom='$nom'")){ //Vrifie si une entre avec le nom ($nom) existe dj
		$db->Update("UPDATE utilisateurs SET date='$maintenant',ip='$ip',image='$img' WHERE nom='$nom'"); //L'entre existe dj, on la met  jour
	}else{
		$db->Insert("INSERT INTO utilisateurs VALUES('','$nom','$maintenant','$ip','$img'"); //Elle n'existe pas, on la crer
	}
	return($db->a_rows); //Renvoie le nombre de lignes modifies dans la base
}

/*
//
// Fonction : GetGuildStatsFromDB()
//
// Ecrit par : Bisous Partout.
// Le : 11/03/06.
//
// Constantes utilises
	ID_GUILD_STATS.
//
// Paramtres :
	Aucun.
//
// Description :
	Renvoie les stats de la guilde stockes dans la base de donnes.
*/
//function GetGuildInfoFromDB(){
function GetGuildStatsFromDB(){
	global $db; //Dclare que la variable $bdd est une variable globale
	if($db->S_Query("SELECT * FROM guild_stat WHERE id=".ID_GUILD_STATS)){ //S'il y a des rsultats dans la base de donnes
		$guild_info=array(); //On crer un tableau
		//On range les info dans le tableau
		$guild_info[0]=$db->data['ranking']; //Rang
		$guild_info[1]=$db->data['rating']; //Classement
		$guild_info[2]=$db->data['wins']; //Victoires
		$guild_info[3]=$db->data['looses']; //Dfaites
		$guild_info[4]=$db->data['date']; //Date de la dernire mise  jour
		////
	}else{ //Si aucun rsultat n'a t trouv
		return($db->rows); //Renvoie le nombre de rsultats trouvs
	}
	return($guild_info); //Renvoie le tableau rempli
}

/*
//
// Fonction : UpdateGuildStatsFromDB()
//
// Ecrit par : Bisous Partout.
// Le : 11/03/06.
//
// Constantes utilises
	ID_GUILD_STATS.
//
// Paramtres :
	Aucun.
//
// Description :
	Met  jour les stats de la guilde dans la base de donnes (une fois par jours)
*/
//function UpdateDBStats(){
function UpdateGuildStatsFromDB(){
	$guild_info=GetGuildInfoFromDB(); //Rcupre les informations de la guilde dans la base de donnes
	//Range les info dans des variables
	$rank=$guild_info[0]; //Rang
	$rating=$guild_info[1]; //Classement
	$wins=$guild_info[2]; //Victoires
	$looses=$guild_info[3]; //Dfaites
	////
	
	$maintenant=date("d/m/Y H:i:s"); //Date de maintenant
	global $db; //Dclare que la variable $bdd est une variable globale
	if($db->S_Query("SELECT date FROM guild_stat WHERE id=".ID_GUILD_STATS)){
		$bd_jour=explode(" ",$db->data['date']); //Extrait la date de cette entre et la prpare pour comparaison
		if(date("d/m/Y")!=$bd_jour[0]){ //Comparaison des deux dates
			$db->Update("UPDATE guild_stat SET ranking='$rank',rating='$rating',wins='$wins',
				looses='$looses',date='$maintenant' WHERE id=".ID_GUILD_STATS); //Met  jour les infos
		}else{ //Si les deux dates ne sont pas diffrentes
			return(0); //On renvoie 0
		}
	}else{ //S'il n'y a pas d'entre dans la base
		$db->Insert("INSERT INTO guild_stat VALUES('','$rank','$rating','$wins','$looses','$maintenant')"); //On crer une entre
	}
	return($db->a_rows); //Renvoie le nombre de lignes modifies dans la base
}

/*
//
// Fonction : GetGuildInfoFromDB()
//
// Ecrit par : Bisous Partout.
// Le : 11/03/06.
//
// Constantes utilises
	ID_GUILD_INFO.
//
// Paramtres :
	Aucun.
//
// Description :
	Renvoie les informations de la guilde stockes dans la base de donnes.
*/
function GetGuildInfoFromDB(){
	global $db; //Dclare que la variable $bdd est une variable globale
	if($db->S_Query("SELECT * FROM guild_stat WHERE id=".ID_GUILD_INFO)){
		$guild_info=array(); //Crer un tableau
		//Range les info dans le tableau
		$guild_info[0]=$db->data['ranking']; //Rang
		$guild_info[1]=$db->data['rating']; //Classement
		$guild_info[2]=$db->data['wins']; //Victoires
		$guild_info[3]=$db->data['looses']; //Dfaites
		$guild_info[4]=$db->data['date']; //Date de mise  jour
		////
	}else{
		return($db->rows); //Renvoie le nombre de rsultat trouv
	}
	return($guild_info); //Renvoie le tableau rempli
}

/*
//
// Fonction : UpdateGuildInfoFromDB()
//
// Ecrit par : Bisous Partout.
// Le : 11/03/06.
//
// Constantes utilises
	ID_GUILD_INFO.
//
// Paramtres :
	Aucun.
//
// Description :
	Met  jour les info de la guilde dans la base de donnes (toutes les 10 minutes)
*/
function UpdateGuildInfoFromDB(){
	$guild_info=GetGuildInfo(); //Appel la fonction permettant de rcuprer les info de la guilde  partir de la page du ladder de GW
	//Range les info dans des variables
	$rank=$guild_info[0]; //Rang
	$rating=$guild_info[4]; //Classement
	$wins=$guild_info[5]; //Victoires
	$looses=$guild_info[6]; //Dfaites
	////
	
	$maintenant=date("d/m/Y H:i:s"); //Date de maintenant
	global $db; //Dclare que la variable $bdd est une variable globale
	if($db->S_Query("SELECT date FROM guild_stat WHERE id=".ID_GUILD_INFO)){ //Vrifie que l'entre existe dans la base
		$db->Update("UPDATE guild_stat SET ranking='$rank',rating='$rating',wins='$wins',
			looses='$looses',date='$maintenant' WHERE id=".ID_GUILD_INFO); //Met  jour l'entre dans la base de donnes
	}else{ //Si elle n'existe pas
		$db->Insert("INSERT INTO guild_stat VALUES('','$rank',
			'$rating','$wins','$looses','$maintenant')"); //Crer l'entre dans la base
	}
	return($db->a_rows); //Renvoie le nombre de lignes modifies dans la base
}
?>